#define MAXBULLETS 10
struct bullets{
	float xpos;
	float ypos;
	float zpos;
	int type;
	int life;
	float anglex;
	float angley;
	float anglez;
	float viewrx;
	float viewry;
};
struct enemybullets{
	float xpos;
	float ypos;
	float zpos;
	int type;
};
struct weapon{
	float speed;
};
float health=100;
class SShip{
public:
	int currentweapon;
	float xangle;
	float yangle;
	float zangle;
	////////This is to store the network information of each ship. Call ParseInfo to populate these variables.	
	char posx[100];
	char posy[100];
	char posz[100];
	char anglex[100];
	char angley[100];
	char anglez[100];
	float listofinfo[100];
	char sshipnetworkinfo[1000];
	char rshipnetworkinfo[1000];
	char tempx[50];
	char tempy[50];
	char tempz[50];
	char tempangle[50];
	char tempangleb[50];
	////////
	char healtht[30];
	float speedx;
	float speedy;
	float speedz;
	float speed;
	float action;
	float topx;
	float topy;
	float topz;
	float topturn;
	
	SShip(GLEngine*shipgraphics,char *shipfile,char *shiptexture,char *shipmultitexture,int textureid,int multitextureid, int objectid);//only one texture per ship right now :-(. Later this function will support more, and shaders, and info for particles systems.
	void DrawShip();
	void DrawNonClientShip();
	void UpDatePostion();
	void ParseInfo();
	void Tokeninze();
	void FireWeapon();
	void DrawBullet();
	bool TestBulletHit(float xb,float yb,float zb);
	weapon weaponstruct[1];
private:
	SSHip();
	void SetupSpeed();
	void UpdateWeaponPosition();
	int ido;
	int idt;
	int midt;
	int numberofcommands;
	void TopSpeed();
	bullets bullet[MAXBULLETS];
	GLEngine*SShipgraphics;
};
SShip::SShip(GLEngine*shipgraphics,char *shipfile,char *shiptexture,char *shipmultitexture,int textureid,int multitextureid, int objectid )
{
	shipgraphics->load3dfile(shipfile,objectid);
	shipgraphics->loadtexture(shiptexture,textureid);
	shipgraphics->loadtexture(shipmultitexture,multitextureid);
	midt=multitextureid;
	ido=objectid;
	idt=textureid;
	xangle=-80;
	yangle=0;
	zangle=0;
	
	speedx=0;
	speedy=0;
	speedz=0;
	action=0;
	speed=0;
	topx=.4;
	topy=.4;
	topz=.4;
	topturn=2.0; 
	health=100;
	SShipgraphics=shipgraphics;
	numberofcommands=0;
	currentweapon=1;
	weaponstruct[0].speed=.5;
	
	for(int i=0;i<MAXBULLETS;i++)
	{
		bullet[i].type=0;
		bullet[i].anglex=0;
		bullet[i].angley=0;
		bullet[i].anglez=0;
		bullet[i].life=0;
		bullet[i].type=0;
		bullet[i].viewrx=0;
		bullet[i].viewry=0;
		bullet[i].xpos=0;
		bullet[i].ypos=0;
		bullet[i].zpos=0;
	}
	

	
}

void SShip::DrawShip()
{
	glPushMatrix();
	glDisable(GL_LIGHTING);
	glLoadIdentity();
	glScalef(.0001,.0001,.0001);
	glTranslatef(0,0,-6000);
	glRotatef(xangle,1,0,0);
	glRotatef(zangle,0,1,0);
	//glRotatef(yangle,0,0,1);
	
	
	SShipgraphics->enablemultitextureunit(0);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	SShipgraphics->selecttexture(idt);
	SShipgraphics->enablemultitextureunit(1);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	SShipgraphics->selecttexture(midt);
	SShipgraphics->enablevertexprograms();
	SShipgraphics->selectvertexprogram(1);
	SShipgraphics->enableregistercombiners();
	SShipgraphics->setupbumpmapping();
	SShipgraphics->drawfile(ido);
	SShipgraphics->disableregistercominbers();
	SShipgraphics->disablevertexprograms();
	SShipgraphics->enablemultitextureunit(0);
	
	glEnable(GL_LIGHTING);
	
	glPopMatrix();
}
bool SShip::TestBulletHit(float xb,float yb,float zb)
{
	
	vertex amountinter={0,0,0};
	vertex point={xb,yb,zb};
	sphereintersect spherer={-SShipgraphics->Translation.Matrixd[0][3],-SShipgraphics->Translation.Matrixd[1][3],-SShipgraphics->Translation.Matrixd[2][3],.2};
	amountinter=SShipgraphics->checksphereintersection(point,spherer);
	//SShipgraphics->file2<<fabs(amountinter.x)<<" "<<fabs(amountinter.y)<<" "<<fabs(amountinter.z)<<endl;
	//SShipgraphics->file2<<xb<<" "<<yb<<" "<<zb<<endl;
	//SShipgraphics->file2<<endl;
	if(fabs(amountinter.x)<spherer.radius&&fabs(amountinter.y)<spherer.radius&&fabs(amountinter.z)<spherer.radius)
	{
		return true;
	}
	else
	{
		return false;
	}
	
}
void SShip::DrawNonClientShip()
{
	
	glPushMatrix();
	glTranslatef(listofinfo[0],listofinfo[1],listofinfo[2]);
	glRotatef(-(listofinfo[4]),0,1,0);
	glRotatef(-(listofinfo[3])+260,1,0,0);
	glRotatef((listofinfo[5]),0,1,0);
	glScalef(.0001,.0001,.0001);
	///Is this right?????????
	
	///
	SShipgraphics->enablemultitextureunit(0);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	SShipgraphics->selecttexture(idt);
	SShipgraphics->enablemultitextureunit(1);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	SShipgraphics->enablevertexprograms();
	SShipgraphics->selectvertexprogram(1);
	SShipgraphics->enableregistercombiners();
	SShipgraphics->setupbumpmapping();
	SShipgraphics->selecttexture(midt);
	SShipgraphics->drawfile(ido);
	SShipgraphics->disableregistercominbers();
	SShipgraphics->disablevertexprograms();
	SShipgraphics->enablemultitextureunit(0);
	glPopMatrix();
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_CULL_FACE);
	for(int i=6;i<(MAXBULLETS*5)+6;i+=5)//This line did read:for(int i=6;i<(MAXBULLETS*5)+6;i+=5)
	{
		
		glPushMatrix();
	//	glLoadIdentity();
		SShipgraphics->selecttexture(4);
		glTranslatef(listofinfo[i],listofinfo[i+1],listofinfo[i+2]);
		bool testhit=TestBulletHit(listofinfo[i],listofinfo[i+1],listofinfo[i+2]);
		if(testhit==true)
		{
			health-=50;
		}
		glRotatef(listofinfo[i+3],0,1,0);
		glRotatef(listofinfo[i+4],1,0,0);
		glBegin(GL_QUADS);
		glColor4f(1,1,1,1);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0,0);
		glVertex3f(0,0,0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0,1);
		glVertex3f(0,1,0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1,1);
		glVertex3f(1,1,0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1,0);
		glVertex3f(1,0,0);		
		/////////////
		/*	glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0,0);
		glVertex3f(0,0,0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0,1);
		glVertex3f(0,1,1);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1,1);
		glVertex3f(0,1,0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1,0);*/
		glVertex3f(0,0,1);	
		/////////
		glEnd();
		glPopMatrix();
	
	
	}
	glEnable(GL_CULL_FACE);
}

void SShip::TopSpeed()
{
	if(speedx>topx)
	{
		speedx=topx;
	}
	if(speedy>topy)
	{
		speedy=topy;
	}
	if(speedz>topz)
	{
		speedz=topz;
	}
	if(speedx<-topx)
	{
		speedx=-topx;
	}
	if(speedy<-topy)
	{
		speedy=-topy;
	}
	if(speedz<-topz)
	{
		speedz=-topz;
	}
}
//////////
void SShip::SetupSpeed()
{
	if(speed!=0)
	{
		if(xangle>=-80)
		{
			float temp=xangle-10;
			float percentagex=0;
			float percentagez=0;
			if(temp!=0)
			{
				percentagex=temp/90;
			}
			percentagex=-percentagex;
			percentagez=1-percentagex;
			if(percentagex!=0)
			{
				speedx=speed*percentagex;
			}
			if(percentagez!=0)
			{
				speedz=speed*-percentagez;
			}
		}
		else
			if(xangle<=-80)
			{
				///////////////
				float temp=(xangle-10)+90;
				float percentagex=0;
				float percentagez=0;
				if(temp!=0)
				{
					percentagez=(temp/90);
				}
				percentagez=(percentagez)+1;
				percentagex=1-percentagez;
				if(percentagex!=0)
				{
					speedz=speed*percentagex;
				}
				if(percentagez!=0)
				{
					speedx=speed*percentagez;
				}
			}
			//////////
	}
}
//////////////
void SShip::UpDatePostion()
{
	SetupSpeed();
	TopSpeed();
	UpdateWeaponPosition();
	ParseInfo();
}
void SShip::FireWeapon()
{
	int weaponindex=-1;
	///
	for(int i=0;i<MAXBULLETS;i++)
	{
		///
		if(bullet[i].type==0)
		{
			weaponindex=i;
			break;
		}
		////
	}
	//////
	if(weaponindex!=-1)
	{
		bullet[i].type=currentweapon;
		bullet[i].life=0;
		bullet[i].xpos=-SShipgraphics->Translation.Matrixd[0][3];
		bullet[i].ypos=-SShipgraphics->Translation.Matrixd[1][3];
		bullet[i].zpos=-SShipgraphics->Translation.Matrixd[2][3];
		
		bullet[i].anglex=-SShipgraphics->Rotation.Matrixd[2][0];
		bullet[i].angley=-SShipgraphics->Rotation.Matrixd[2][1];
		bullet[i].anglez=-SShipgraphics->Rotation.Matrixd[2][2];
		
		bullet[i].viewrx=-SShipgraphics->g_ViewAngle/0.017453292519943295769236907684886;
		bullet[i].viewry=-SShipgraphics->g_ViewAnglez/0.017453292519943295769236907684886;
		
	}
}
void SShip::UpdateWeaponPosition()
{
	for(int i=0;i<MAXBULLETS;i++){
		if(bullet[i].type!=0)
		{
			bullet[i].xpos+=bullet[i].anglex*weaponstruct[bullet[i].type-1].speed;
			bullet[i].ypos+=bullet[i].angley*weaponstruct[bullet[i].type-1].speed;
			bullet[i].zpos+=bullet[i].anglez*weaponstruct[bullet[i].type-1].speed;
			bullet[i].life++;
			if(bullet[i].life>50)
			{
				bullet[i].life=0;
				bullet[i].type=0;
				bullet[i].xpos=0;
				bullet[i].ypos=0;
				bullet[i].zpos=0;
				bullet[i].anglex=0;
				bullet[i].angley=0;
				bullet[i].anglez=0;
				bullet[i].viewrx=0;
				bullet[i].viewry=0;
			}
		}
	}
}

void SShip::DrawBullet()
{
	for(int i=0;i<MAXBULLETS;i++)
	{
		if(bullet[i].type==1)
		{
			glDisable(GL_CULL_FACE);
			glPushMatrix();
			glTranslatef(bullet[i].xpos,bullet[i].ypos,bullet[i].zpos);
			
			glRotatef(bullet[i].viewrx,0,1,0);
			glRotatef(bullet[i].viewry,1,0,0);
			glBegin(GL_QUADS);
			glColor4f(1,1,1,1);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0,0);
			glVertex3f(0,0,0);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0,1);
			glVertex3f(0,1,0);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1,1);
			glVertex3f(1,1,0);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1,0);
			glVertex3f(1,0,0);		
			/////////////
			/*	glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0,0);
			glVertex3f(0,0,0);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0,1);
			glVertex3f(0,1,1);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1,1);
			glVertex3f(0,1,0);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1,0);*/
			glVertex3f(0,0,1);
			/////////
			glEnd();
			glPopMatrix();
			glEnable(GL_CULL_FACE);
		}
	}
}
void SShip::ParseInfo()
{
	strcpy(sshipnetworkinfo,"");
	_gcvt(-SShipgraphics->Translation.Matrixd[0][3],20,posx);
	_gcvt(-SShipgraphics->Translation.Matrixd[1][3],20,posy);
	_gcvt(-SShipgraphics->Translation.Matrixd[2][3],20,posz);
	
	/////////
	_gcvt(SShipgraphics->g_ViewAnglez/0.017453292519943295769236907684886,10,anglex);
	_gcvt(SShipgraphics->g_ViewAngle/0.017453292519943295769236907684886,10,angley);
	_gcvt(zangle,10,anglez);
	
	
	strcat(sshipnetworkinfo,posx);
	strcat(sshipnetworkinfo,"x");
	strcat(sshipnetworkinfo,posy);
	strcat(sshipnetworkinfo,"x");
	strcat(sshipnetworkinfo,posz);
	strcat(sshipnetworkinfo,"x");
	strcat(sshipnetworkinfo,anglex);
	strcat(sshipnetworkinfo,"x");
	strcat(sshipnetworkinfo,angley);
	strcat(sshipnetworkinfo,"x");
	strcat(sshipnetworkinfo,anglez);
	strcat(sshipnetworkinfo,"x");
	for(int i=0;i<MAXBULLETS;i++)
	{
		_gcvt(bullet[i].xpos,20,tempx);
		_gcvt(bullet[i].ypos,20,tempy);
		_gcvt(bullet[i].zpos,20,tempz);
		_gcvt(bullet[i].viewrx,20,tempangle);
		_gcvt(bullet[i].viewry,20,tempangleb);
	//	_gcvt(bullet[i].life,20,tempbulletl);
		strcat(sshipnetworkinfo,tempx);
		strcat(sshipnetworkinfo,"x");
		strcat(sshipnetworkinfo,tempy);
		strcat(sshipnetworkinfo,"x");
		strcat(sshipnetworkinfo,tempz);
		strcat(sshipnetworkinfo,"x");
		strcat(sshipnetworkinfo,tempangle);
		strcat(sshipnetworkinfo,"x");
		strcat(sshipnetworkinfo,tempangleb);
		strcat(sshipnetworkinfo,"x");

		
	}
	
	//SShipgraphics->file2<<sshipnetworkinfo<<endl;
	
	
}
void SShip::Tokeninze()
{
	char * token;
	int indexintofloat=0;
	float temp;
	token = strtok( rshipnetworkinfo, "x" );
	while( token != NULL )
	{
		temp=atof(token);
		
		listofinfo[indexintofloat]=temp;
		indexintofloat++;
		token = strtok( NULL, "x" );
	}
	
	numberofcommands=indexintofloat;
	
}