/* Copyright (c) Jesse Laeuchli 2000. */
typedef vector<float> floatvct;
typedef vector<int> intvct;
struct Chunk{
	char chunktype[4];
	short major;
	short minor;
	long id;
	long parent;
	long size;
};


class TrueSpace{
public:
	vertex *pVertex;
	
	char texfilename[256];
public:
	floatvct VERTEXX;
	floatvct VERTEXY;
	floatvct VERTEXZ;
	floatvct UVVERTEXU;
	floatvct UVVERTEXV;
	intvct FACESV;
	intvct FACESUV;
	intvct VERTEXC;
	intvct TC;
	intvct VC;
	intvct IC;
	intvct VCC;
	int totalic;
	int numberofpoly;
	int texturecount;
	int vertexcount;
	int indexcount;
	int vertexccount;
	char nm[50];
	TrueSpace(){VC.push_back(0);TC.push_back(0);numberofpoly=0;vertexccount=0;indexcount=0;vertexcount=0;texturecount=0;totalic=0;};
	~TrueSpace(){delete pVertex;}
protected:
	int ReadByte(char& value)
	{return(fread(&value,sizeof(value),1,fp))==1;}
	int ReadUByte(unsigned char& value)
	{return(fread(&value,sizeof(value),1,fp))==1;}
	int ReadShort(short& value)
	{return(fread(&value,sizeof(value),1,fp))==1;}
	int ReadLong(long& value)
	{return(fread(&value,sizeof(value),1,fp))==1;}
	int ReadFloat(float& value)
	{return(fread(&value,sizeof(value),1,fp))==1;}
	int ReadString(char *name)
	{
		short length;
		if(!ReadShort(length))return false;
		for(int i=0;i<length;i++){
			if(!ReadByte(name[i]))return false;
		}
		///
		name[i]='\0';
		return true;
	}
	void readpolchunk()
	{
		ReadName(nm);
		ReadLocalAxis();
		ReadCurrentPosition();
		ReadVertexList();
		ReadUVVertexList();
		ReadPolyFace();
		TC.push_back(texturecount);
		VC.push_back(vertexcount);
		IC.push_back(indexcount);
		VCC.push_back(vertexccount);
		totalic+=indexcount;
		//indexcount+=indexcount;
		numberofpoly++;
	}	
	float matrix[4][4];
	FILE*fp;
	bool ReadChunk(Chunk &chunk)
	{
		if(!ReadByte(chunk.chunktype[0]))return false;
		if(!ReadByte(chunk.chunktype[1]))return false;
		if(!ReadByte(chunk.chunktype[2]))return false;
		if(!ReadByte(chunk.chunktype[3]))return false;
		chunk.chunktype[4]='\0';
		if(!ReadShort(chunk.major))return false;
		if(!ReadShort(chunk.minor))return false;
		if(!ReadLong(chunk.id))return false;
		if(!ReadLong(chunk.parent))return false;
		if(!ReadLong(chunk.size))return false;
		return true;
	}
	bool ReadHeader(char*header)
	{
		for(int i=0;i<32;i++){
			if(!ReadByte(header[i]))return false;
		}
		return (strncmp(header,"Caligari ",9)==0 && header[15]=='B');
	}
	int ReadName(char*names)
	{
		short dupcount;
		if(!ReadShort(dupcount))return false;
		return ReadString(names);
	}
	int ReadLocalAxis()
	{
		float 	c_x, c_y, c_z;
		float	x_x, x_y, x_z;
		float	y_x, y_y, y_z;
		float	z_x, z_y, z_z;
		
		if (!ReadFloat( c_x)) return false;
		if (!ReadFloat( c_y)) return false;
		if (!ReadFloat( c_z)) return false;
		//center = SFVec3f(c_x, c_y, c_z);
		
		if (!ReadFloat( x_x)) return false;
		if (!ReadFloat( x_y)) return false;
		if (!ReadFloat( x_z)) return false;
		//x_axis = SFVec3f(x_x, x_y, x_z);
		
		if (!ReadFloat( y_x)) return false;
		if (!ReadFloat( y_y)) return false;
		if (!ReadFloat( y_z)) return false;
		//y_axis = SFVec3f(y_x, y_y, y_z);
		
		if (!ReadFloat( z_x)) return false;
		if (!ReadFloat( z_y)) return false;
		if (!ReadFloat( z_z)) return false;
		//z_axis = SFVec3f(z_x, z_y, z_z);
		
		return true;
	}
	int ReadUVVertexList()
	{
		long count;
		float u,v;
		if (!ReadLong(count)) return false;
		for (long i = 0; i < count; i++) {
			if (!ReadFloat(u)) return false;
			if (!ReadFloat(v)) return false;
			UVVERTEXU.push_back(u);
			UVVERTEXV.push_back(v);
			texturecount+=2;
		}
		
		return true;
	}
	int ReadCurrentPosition()
	{
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 4; j++) {
				float value;
				if (!ReadFloat( value)) return true;
				matrix[j][i] = value;
			}
		}
		for (int j = 0; j < 4; j++) {
			matrix[j][3] = (j != 3 ? (float) 0.0 : (float) 1.0);
		}
		
		return true;
	}
	int ReadVertexList()
	{
		long count;
		float x,y,z=0;
		if(!ReadLong(count))return false;
		for(long i=0;i<count;i++){
			if(!ReadFloat(x))return false;
			if(!ReadFloat(y))return false;
			if(!ReadFloat(z))return false;
			VERTEXX.push_back(x);
			VERTEXY.push_back(y);
			VERTEXZ.push_back(z);
			vertexcount+=3;
		}
		return true;
	}
	int ReadPolyFace()
	{
		long			count;
		unsigned char	flag;
		short			v_count;
		short			m_index;
		long			v_index, uv_index;
		if(!ReadLong(count))return false;
		for (long i = 0; i < count; i++) 
		{
			if (!ReadUByte(flag)) return false;
			if (!ReadShort(v_count)) return false;
			VERTEXC.push_back(v_count);
			vertexccount++;
			if (!ReadShort( m_index)) return false;
			//cout<<"MI"<<m_index<<endl;
			for (long j = 0; j < v_count; j++) {
				if (!ReadLong(v_index)) return false;
				if (!ReadLong(uv_index)) return false;
				
				//cout<<flag<<endl;
				//cout <<v_count<<endl;
				//cout <<uv_index<<endl;
				//cout<<v_index<<" ";
				FACESV.push_back(v_index);
				FACESUV.push_back(uv_index);
				indexcount++;
			}
		}
		return true;
	}
	int ReadMat()
	{
		char		shader_type, facet_type, autofacet_angle;
		float		red, green, blue;
		float		opacity, ambient, specular, hilight, ior;
		char		ident[2];
		short mat_number;
		// Manditory values
		if (!ReadShort(mat_number)) return false;
		if (!ReadByte(shader_type)) return false;
		if (!ReadByte(facet_type)) return false;
		if (!ReadByte(autofacet_angle)) return false;
		if (!ReadFloat(red)) return false;
		if (!ReadFloat(green)) return false;
		if (!ReadFloat(blue)) return false;
		if (!ReadFloat(opacity)) return false;
		if (!ReadFloat(ambient)) return false;
		if (!ReadFloat(specular)) return false;
		if (!ReadFloat(hilight)) return false;
		if (!ReadFloat(ior)) return false;
		if (!ReadByte(ident[0])) return false;
		if (!ReadByte(ident[1])) return false;
		if (strncmp(ident, "t:", 2) == 0) { 
			char	flags;
			float	u_offset, v_offset, u_repeat, v_repeat;
			
			if (!ReadByte( flags)) return false;
			if (!ReadString(texfilename)) return false;
			if (!ReadFloat(u_offset)) return false;
			if (!ReadFloat(v_offset)) return false;
			if (!ReadFloat(u_repeat)) return false;
			if (!ReadFloat(v_repeat)) return false;
			
			// Get next identifier 
		}
		return true;
	}
	//Turn the faces of the truespace file to triangles.....
	void mtriangle(int sizeofmem)
	{
		pVertex=new vertex[sizeofmem];
		////
		for(int i=0;i<sizeofmem;i++)
		{
			pVertex[i].x=VERTEXX[FACESV[i]];
			pVertex[i].y=VERTEXY[FACESV[i]];
			pVertex[i].z=VERTEXZ[FACESV[i]];
			pVertex[i].u=UVVERTEXU[FACESUV[i]];
			pVertex[i].v=UVVERTEXV[FACESUV[i]];
			/*int a;
			cout<<pVertex[i].x<<" "<<pVertex[i].y<<" "<<pVertex[i].z<<endl;
			cin>>a;
			*/
		}
		////
		
	}
};
class ReadSCNFile:public TrueSpace
{
	
private:
	ReadSCNFile();
public:
	
	ReadSCNFile(char *scnfile);
	~ReadSCNFile(){};
};
ReadSCNFile::ReadSCNFile(char *scnfile)
{
	char test2[50];
	FILE *file;
	file=fopen(scnfile,"rb");
	fp=file;
	bool test3=ReadHeader(test2);
	if(test3==true)
	{
		int q;
		q=0;//cout<<"COB FILES SIR"<<endl;
	}
	Chunk ischunk;
	//fseek(file,106,SEEK_CUR);
	while(ReadChunk(ischunk))
	{
		if(!strcmp(ischunk.chunktype,"PolH"))
		{
			readpolchunk();
		}
		else
			if(!strcmp(ischunk.chunktype,"Mat1"))
			{
				//cout<<"Mat"<<endl;
				ReadMat();
				//fseek(file,ischunk.size,SEEK_CUR);
			}
			else
			{
				//cout<<ischunk.chunktype<<endl;
				fseek(file,ischunk.size,SEEK_CUR);
			}
	}
	mtriangle(indexcount);
}
